Index: code/trunk/src/orxonox/hud/BarOverlayElement.cc
===================================================================
--- code/trunk/src/orxonox/hud/BarOverlayElement.cc	(revision 1391)
+++ code/trunk/src/orxonox/hud/BarOverlayElement.cc	(revision 1392)
@@ -27,6 +27,4 @@
 
 #include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
-#include <OgrePanelOverlayElement.h>
 #include "GraphicsEngine.h"
 #include "BarOverlayElement.h"
@@ -36,5 +34,5 @@
   using namespace Ogre;
 
-    BarOverlayElement::BarOverlayElement(const String& name):Ogre::PanelOverlayElement(name){
+    BarOverlayElement::BarOverlayElement(const String& name):PanelOverlayElement(name){
         name_ = name;
     }
@@ -42,8 +40,8 @@
     BarOverlayElement::~BarOverlayElement(){}
 
-    void BarOverlayElement::init(Real leftRel, Real topRel, Real dimRel, Ogre::OverlayContainer* container){
+    void BarOverlayElement::init(Real leftRel, Real topRel, Real dimRel, OverlayContainer* container){
         // init some values...
         container_ = container;
-        om = &Ogre::OverlayManager::getSingleton();
+        om = &OverlayManager::getSingleton();
         value_ = 0;
         color_ = 2;
@@ -53,10 +51,10 @@
         topRel_ = topRel;
         dimRel_ = dimRel;
-        
+
         // create background...
         background_ = static_cast<OverlayContainer*>(om->createOverlayElement("Panel", name_+"container"));
         background_->show();
         container_->addChild(background_);
-        background_->setMetricsMode(Ogre::GMM_PIXELS);
+        background_->setMetricsMode(GMM_PIXELS);
         background_->setMaterialName("Orxonox/BarBackground");
 
@@ -65,5 +63,5 @@
 
         show();
-        setMetricsMode(Ogre::GMM_PIXELS);
+        setMetricsMode(GMM_PIXELS);
         setMaterialName("Orxonox/Green");
         background_->addChild(this);
Index: code/trunk/src/orxonox/hud/BarOverlayElement.h
===================================================================
--- code/trunk/src/orxonox/hud/BarOverlayElement.h	(revision 1391)
+++ code/trunk/src/orxonox/hud/BarOverlayElement.h	(revision 1392)
@@ -30,12 +30,8 @@
 #define _BAR_H__
 
-#include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
+
 #include <OgrePanelOverlayElement.h>
-
 #include <OgrePrerequisites.h>
 #include "../OrxonoxPrereqs.h"
-
-
 
 namespace orxonox
Index: code/trunk/src/orxonox/hud/HUD.cc
===================================================================
--- code/trunk/src/orxonox/hud/HUD.cc	(revision 1391)
+++ code/trunk/src/orxonox/hud/HUD.cc	(revision 1392)
@@ -26,18 +26,18 @@
 */
 
-
+#include <string.h>
 #include "OrxonoxStableHeaders.h"
 #include <OgreOverlay.h>
 #include <OgreOverlayContainer.h>
 #include <OgreOverlayManager.h>
-#include <OgreSceneNode.h>
-#include <OgreEntity.h>
 #include <OgreStringConverter.h>
+
 #include "core/Debug.h"
+#include "core/ConsoleCommand.h"
 #include "objects/SpaceShip.h"
-#include "HUD.h"
 #include "BarOverlayElement.h"
 #include "RadarOverlayElement.h"
 #include "OverlayElementFactories.h"
+#include "HUD.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/hud/HUD.h
===================================================================
--- code/trunk/src/orxonox/hud/HUD.h	(revision 1391)
+++ code/trunk/src/orxonox/hud/HUD.h	(revision 1392)
@@ -30,9 +30,6 @@
 #define _HUD_H__
 
-#include <string.h>
-#include <OgreOverlayElement.h>
+#include <OgrePrerequisites.h>
 #include <OgreTextAreaOverlayElement.h>
-#include <OgrePrerequisites.h>
-
 #include "OrxonoxPrereqs.h"
 #include "core/Tickable.h"
Index: code/trunk/src/orxonox/hud/RadarObject.cc
===================================================================
--- code/trunk/src/orxonox/hud/RadarObject.cc	(revision 1391)
+++ code/trunk/src/orxonox/hud/RadarObject.cc	(revision 1392)
@@ -26,4 +26,9 @@
 */
 
+#include <string.h>
+#include <OgreOverlayManager.h>
+#include <OgrePanelOverlayElement.h>
+#include <OgreStringConverter.h>
+#include <util/Math.h>
 #include "RadarObject.h"
 
@@ -34,5 +39,5 @@
 	int RadarObject::count = 0;		// initialize static variable
 
-	RadarObject::RadarObject(Ogre::OverlayContainer* container){
+	RadarObject::RadarObject(OverlayContainer* container){
 		container_ = container;
 		pos_ = Vector3(0.0, 0.0, 0.0);
@@ -40,5 +45,5 @@
 	}
 
-	RadarObject::RadarObject(Ogre::OverlayContainer* container, Vector3 pos){
+	RadarObject::RadarObject(OverlayContainer* container, Vector3 pos){
 		container_ = container;
 		pos_ = pos;
@@ -50,7 +55,7 @@
 	void RadarObject::init(){
 	    next = NULL;
-		om = &Ogre::OverlayManager::getSingleton();
+		om = &OverlayManager::getSingleton();
 		panel_ = static_cast<PanelOverlayElement*>(om->createOverlayElement("Panel",
-			"Object"+Ogre::StringConverter::toString(count)));
+			"Object"+StringConverter::toString(count)));
 		panel_->setMaterialName("Orxonox/RedDot");
 		panel_->setDimensions(3,3);
Index: code/trunk/src/orxonox/hud/RadarObject.h
===================================================================
--- code/trunk/src/orxonox/hud/RadarObject.h	(revision 1391)
+++ code/trunk/src/orxonox/hud/RadarObject.h	(revision 1392)
@@ -29,12 +29,5 @@
 #define _RADAR2_H__
 
-#include <string.h>
 #include <OgrePrerequisites.h>
-#include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
-#include <OgrePanelOverlayElement.h>
-#include <OgreStringConverter.h>
-
-#include <util/Math.h>
 #include "../OrxonoxPrereqs.h"
 
Index: code/trunk/src/orxonox/hud/RadarOverlayElement.cc
===================================================================
--- code/trunk/src/orxonox/hud/RadarOverlayElement.cc	(revision 1391)
+++ code/trunk/src/orxonox/hud/RadarOverlayElement.cc	(revision 1392)
@@ -25,5 +25,16 @@
 *
 */
-
+#include <string.h>
+
+
+#include <string.h>
+#include <OgreOverlayManager.h>
+#include <OgreStringConverter.h>
+#include <OgrePanelOverlayElement.h>
+
+#include "GraphicsEngine.h"
+#include "core/Tickable.h"
+#include "core/ConsoleCommand.h"
+#include "objects/SpaceShip.h"
 #include "RadarOverlayElement.h"
 
@@ -33,5 +44,5 @@
     using namespace Ogre;
 
-    RadarOverlayElement::RadarOverlayElement(const String& name):Ogre::PanelOverlayElement(name){
+    RadarOverlayElement::RadarOverlayElement(const String& name):PanelOverlayElement(name){
     }
 
@@ -39,7 +50,7 @@
     }
 
-    void RadarOverlayElement::init(Real leftRel, Real topRel, Real dimRel, Ogre::OverlayContainer* container){
+    void RadarOverlayElement::init(Real leftRel, Real topRel, Real dimRel, OverlayContainer* container){
         // some initial data
-		om = &Ogre::OverlayManager::getSingleton();
+		om = &OverlayManager::getSingleton();
         dimRel_ = dimRel;
         leftRel_ = leftRel;
@@ -52,5 +63,5 @@
         // create nav marker ...
         navMarker_ = static_cast<PanelOverlayElement*>(om->createOverlayElement("Panel", "NavMarker"));
-        navMarker_->setMetricsMode(Ogre::GMM_PIXELS);
+        navMarker_->setMetricsMode(GMM_PIXELS);
         navMarker_->setMaterialName("Orxonox/NavMarker");
         navMarker_->setDimensions(16,16);
@@ -67,5 +78,5 @@
         plane = Plane(currentDir_, shipPos_);
 
-        setMetricsMode(Ogre::GMM_PIXELS);
+        setMetricsMode(GMM_PIXELS);
         setMaterialName("Orxonox/Radar");
         resize();
@@ -189,5 +200,5 @@
 	float RadarOverlayElement::calcPhi(RadarObject* obj){
 	    // project difference vector on our plane...
-	    Ogre::Vector3 proj = plane.projectVector(obj->pos_ - shipPos_);
+	    Vector3 proj = plane.projectVector(obj->pos_ - shipPos_);
 	    // ...and find out the angle
 	    return(acos((currentOrth_.dotProduct(proj))/
Index: code/trunk/src/orxonox/hud/RadarOverlayElement.h
===================================================================
--- code/trunk/src/orxonox/hud/RadarOverlayElement.h	(revision 1391)
+++ code/trunk/src/orxonox/hud/RadarOverlayElement.h	(revision 1392)
@@ -29,19 +29,8 @@
 #define _RADAR_H__
 
-#include <string.h>
-#include <OgreOverlayManager.h>
-#include <OgreStringConverter.h>
-#include <OgreOverlayElement.h>
-#include <OgrePanelOverlayElement.h>
+#include <util/Math.h>
 #include <OgrePrerequisites.h>
-
-#include <util/Math.h>
-#include <string.h>
-#include "core/Tickable.h"
-#include "core/ConsoleCommand.h"
-#include "objects/SpaceShip.h"
 #include "../OrxonoxPrereqs.h"
 #include "RadarObject.h"
-#include "GraphicsEngine.h"
 
 namespace orxonox