Index: /code/branches/network/src/core/InputHandler.cc
===================================================================
--- /code/branches/network/src/core/InputHandler.cc	(revision 1397)
+++ /code/branches/network/src/core/InputHandler.cc	(revision 1398)
@@ -33,4 +33,5 @@
 
 #include "InputHandler.h"
+#include <fstream>
 #include "util/Convert.h"
 #include "util/SubString.h"
@@ -469,6 +470,15 @@
     COUT(3) << "KeyBinder: Loading key bindings..." << std::endl;
 
+    clearBindings();
+
+    /*std::ifstream infile;
+    infile.open("keybindings.ini");
+    if (!infile.is_open())
+    {
+      ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, "keybindings_def.ini");
+      setConfigValues();
+    }
+    infile.close();*/
     ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, "keybindings.ini");
-    clearBindings();
     setConfigValues();
 
@@ -486,4 +496,5 @@
     SetConfigValue(derivePeriod_, 0.1f).description("Accuracy of the mouse input deriver. The higher the more precise, but laggier.");
     SetConfigValue(mouseSensitivityDerived_, 1.0f).description("Mouse sensitivity if mouse input is derived.");
+    SetConfigValue(keybindingsDefault_, "keybindings_def.ini").description("Default ini file for the keybindings.");
 
     float oldThresh = buttonThreshold_;
@@ -580,5 +591,5 @@
       if (halfAxes_[i].relVal_ > analogThreshold_ || halfAxes_[i].absVal_ > analogThreshold_)
       {
-        COUT(3) << halfAxes_[i].name_ << "\t" << halfAxes_[i].absVal_ << std::endl;
+        //COUT(3) << halfAxes_[i].name_ << "\t" << halfAxes_[i].absVal_ << std::endl;
         halfAxes_[i].execute();
       }
Index: /code/branches/network/src/core/InputHandler.h
===================================================================
--- /code/branches/network/src/core/InputHandler.h	(revision 1397)
+++ /code/branches/network/src/core/InputHandler.h	(revision 1398)
@@ -226,4 +226,6 @@
     //! mouse sensitivity if mouse input is derived
     float mouseSensitivityDerived_;
+    //! default ini file for the keybindings
+    std::string keybindingsDefault_;
   };
 
Index: /code/branches/network/src/core/InputManager.cc
===================================================================
--- /code/branches/network/src/core/InputManager.cc	(revision 1397)
+++ /code/branches/network/src/core/InputManager.cc	(revision 1398)
@@ -409,5 +409,4 @@
           enableKeyHandler("keybinder");
           enableMouseHandler("keybinder");
-          enableMouseHandler("SpaceShip");
           enableJoyStickHandler("keybinder", 0);
           break;
@@ -419,5 +418,4 @@
         case IS_CONSOLE:
           enableMouseHandler("keybinder");
-          enableMouseHandler("SpaceShip");
           enableJoyStickHandler("keybinder", 0);
           enableKeyHandler("buffer");
Index: /code/branches/network/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1397)
+++ /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1398)
@@ -159,14 +159,4 @@
     void SpaceShip::init()
     {
-        if ((server_ || ( network::Client::getSingleton() && network::Client::getSingleton()->getShipID()==objectID ) ))
-        {
-              if (!setMouseEventCallback_)
-              {
-                  InputManager::addMouseHandler(this, "SpaceShip");
-                  InputManager::enableMouseHandler("SpaceShip");
-                  setMouseEventCallback_ = true;
-              }
-        }
-
         // START CREATING THRUSTER
         this->tt_ = new ParticleInterface(GraphicsEngine::getSingleton().getSceneManager(),"twinthruster" + this->getName(),"Orxonox/engineglow");
@@ -314,19 +304,4 @@
     }
 
-    void SpaceShip::mouseButtonPressed(MouseButton::Enum id)
-    {
-        if (id == MouseButton::Right)
-            this->bRMousePressed_ = true;
-    }
-
-    void SpaceShip::mouseButtonReleased(MouseButton::Enum id)
-    {
-        if (id == MouseButton::Right)
-        {
-            this->bRMousePressed_ = false;
-            this->camNode_->resetOrientation();
-        }
-    }
-
     std::string SpaceShip::whereAmI() {
 	return getConvertedValue<float, std::string>(SpaceShip::getLocalShip()->getPosition().x)
Index: /code/branches/network/src/orxonox/objects/SpaceShip.h
===================================================================
--- /code/branches/network/src/orxonox/objects/SpaceShip.h	(revision 1397)
+++ /code/branches/network/src/orxonox/objects/SpaceShip.h	(revision 1398)
@@ -41,5 +41,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport SpaceShip : public Model, public MouseHandler
+    class _OrxonoxExport SpaceShip : public Model
     {
         public:
@@ -78,10 +78,4 @@
             static void moveLateral(float value);
             static void fire();
-
-            void mouseButtonPressed (MouseButton::Enum id);
-            void mouseButtonReleased(MouseButton::Enum id);
-            void mouseButtonHeld    (MouseButton::Enum id) { }
-            void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) { }
-            void mouseScrolled      (int abs, int rel) { }
 
             float getMaxSpeed();